/* This file is part of Idest.
   Copyright (C) 2009 Sergey Poznyakoff
 
   Idest is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.
 
   Idest is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with Idest.  If not, see <http://www.gnu.org/licenses/>. */

struct id3v1_block {
	char header[3];
	char title[30];
	char artist[30];
	char album[30];
	char year[4];
	char comment[28];
	char pad[1];
	char track[1];
	char genre[1];
};

#define ID3V1_TAG "TAG"
#define ID3V1_HEADER_LEN 3

#define ID3V1_SET(blk, name, value) do {				\
		if (value)						\
			id3v1_copy_string(#name, (blk)->name,		\
					  sizeof((blk)->name), value);	\
	} while(0)
	  
const char *id3v1_n_to_genre(unsigned n);
int id3v1_genre_to_n(const char *genre);
void id3v1_init(struct id3v1_block *blk);
void id3v1_copy_string(const char *name, char *ptr, size_t size,
		       const char *arg);
int id3v1_read(FILE *fp, struct id3v1_block *blk);
int id3v1_write(FILE *fp, struct id3v1_block *blk);
void id3v1_merge(struct id3v1_block *id, const struct id3v1_block *old);


